#region Copyright Syncfusion Inc. 2001 - 2014
// Copyright Syncfusion Inc. 2001 - 2014. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Syncfusion.Windows.Controls.Grid;
using Syncfusion.Windows.Shared;
using System.Collections.Specialized;
using Syncfusion.Windows.Styles;
using System.ComponentModel;
using System.Diagnostics;
using Syncfusion.Windows.Controls.Cells;

namespace SelfRelationalDatabindingDemo
{
    public partial class MainWindow :Window
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="MainWindow"/> class.
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();
            this.treeGrid.Loaded += treeGrid_Loaded;   
        }

        void treeGrid_Loaded(object sender, RoutedEventArgs e)
        {
            this.treeGrid.InternalGrid.SelectionChanged += InternalGrid_SelectionChanged;
        }

        void InternalGrid_SelectionChanged(object sender, GridSelectionChangedEventArgs e)
        {
            //getting the selected node
            var viewModel = this.treeGrid.DataContext as ViewModel;
            viewModel.GridTreeNode = (this.treeGrid.SelectedNode as GridTreeNode).Item;
            var parentItem = (this.treeGrid.SelectedNode as GridTreeNode).ParentItem;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var viewModel = this.treeGrid.DataContext as ViewModel;
            //adding the below item as parent node
            if(treeGrid.SelectedNodes.Count==0)
                  viewModel.PersonDetails.Add(new PersonInfo() { LastName = "Sunil", FirstName = "Pradap", MyEyeColor = "Gray", DOB = new DateTime() });
            //adding the child node
            if(treeGrid.SelectedNodes.Count!=0)
            {
                var parentNode = treeGrid.SelectedNodes[0];
                var person = new PersonInfo();
                person.LastName = "Dzmitry";
                person.FirstName = "Dzmitry";
                person.MyEyeColor = "Black";
                person.DOB = new DateTime();
                var newNode = new GridTreeNode(parentNode.Level + 1, person, false, parentNode);
                if (!parentNode.HasChildNodes)
                {
                    parentNode.HasChildNodes = true;
                    parentNode.ChildNodes = new List<GridTreeNode>();
                }
                parentNode.ChildNodes.Add(newNode);
                this.treeGrid.InternalGrid.InvalidateCells();   
            }
        }
    }
}
